import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A faller class to represent all falling objects
 * 
 * @author Jan Hartman
 * @version 1.0 5.8.2022
 */
public abstract class Faller extends Actor
{
    int fallingSpeed; // how fast the object is falling
    int life; // counts how many act cycles since its creation it lived
    int fallDelay; // amount of act cycles the object stands before falling 
    /**
     * Act - do whatever the Pizza wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    public Faller(int fallingSpeed)
    {
        this.fallingSpeed = fallingSpeed;
        life = 0;
    }
    
    
    /**
     * Causes the faller object to fall down after a delay
     */
    public void act()
    {
        life++;
        if (life > fallDelay){
            fall(fallingSpeed);
            removeIfEdge();
        }
    }
    
    /**
     * Makes the object fall
     */
    public void fall(int speed)
    {
        setLocation(getX(), getY()+speed);  
    }
    
    /**
     * Removes the object if it is on the edge
     */
    private void removeIfEdge()
    {
        if (isAtEdge()) getWorld().removeObject(this);
    }
}
