import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A tasty pizza
 * 
 * @author Jan Hartman 
 * @version 1.0 5.8.2022
 */
public class Pizza extends Faller
{
    private int turningSpeed = 1;
    private int turningAngle = 15;
    
    /**
     * Creates a new Pizza with its initial falling speed and fall delay
     */
    public Pizza(int fallingSpeed)
    {
        super(fallingSpeed);
        fallDelay = 30;
    }
    
    public void act(){
        turn();
        super.act();
    }
    
    public void turn(){
        int nextRotation = getRotation() + turningSpeed;
        if (nextRotation > turningAngle || nextRotation < -turningAngle){
            turningSpeed = -turningSpeed;
        }
        turn(turningSpeed);
    }

}
